/******************************************************************************
 * This file was generated by langium-cli 1.1.0.
 * DO NOT EDIT MANUALLY!
 ******************************************************************************/

/* eslint-disable */
import { AstNode, AbstractAstReflection, Reference, ReferenceInfo, TypeMetaData } from 'langium';

export type AbstractElement = EnumX | Module;

export const AbstractElement = 'AbstractElement';

export function isAbstractElement(item: unknown): item is AbstractElement {
    return reflection.isInstance(item, AbstractElement);
}

export type AttributesMapper = Equal;

export const AttributesMapper = 'AttributesMapper';

export function isAttributesMapper(item: unknown): item is AttributesMapper {
    return reflection.isInstance(item, AttributesMapper);
}

export type DATATYPE = 'boolean' | 'char' | 'date' | 'datetime' | 'decimal' | 'integer' | 'string' | 'uuid';

export type Entity = LocalEntity;

export const Entity = 'Entity';

export function isEntity(item: unknown): item is Entity {
    return reflection.isInstance(item, Entity);
}

export type QualifiedName = string;

export type QualifiedNameWithWildcard = string;

export type Relation = ManyToMany | ManyToOne | OneToMany | OneToOne;

export const Relation = 'Relation';

export function isRelation(item: unknown): item is Relation {
    return reflection.isInstance(item, Relation);
}

export type WhenMapper = EqualWhen;

export const WhenMapper = 'WhenMapper';

export function isWhenMapper(item: unknown): item is WhenMapper {
    return reflection.isInstance(item, WhenMapper);
}

export interface Application extends AstNode {
    readonly $type: 'Application';
    abstractElements: Array<AbstractElement>
    configuration?: Configuration
}

export const Application = 'Application';

export function isApplication(item: unknown): item is Application {
    return reflection.isInstance(item, Application);
}

export interface Attribute extends AstNode {
    readonly $container: LocalEntity;
    readonly $type: 'Attribute';
    description?: string
    fullName?: string
    name: string
    type: DATATYPE
    unique: boolean
}

export const Attribute = 'Attribute';

export function isAttribute(item: unknown): item is Attribute {
    return reflection.isInstance(item, Attribute);
}

export interface AttributeEnum extends AstNode {
    readonly $container: EnumX;
    readonly $type: 'AttributeEnum';
    description?: string
    fullName?: string
    name: string
}

export const AttributeEnum = 'AttributeEnum';

export function isAttributeEnum(item: unknown): item is AttributeEnum {
    return reflection.isInstance(item, AttributeEnum);
}

export interface Configuration extends AstNode {
    readonly $container: Application;
    readonly $type: 'Configuration';
    about: string
    author: string
    author_email: string
    bootstrap_servers: string
    database_name: string
    framework: string
    package_path: string
    repository: string
    software_name: string
    topic_pattern: string
}

export const Configuration = 'Configuration';

export function isConfiguration(item: unknown): item is Configuration {
    return reflection.isInstance(item, Configuration);
}

export interface EnumEntityAtribute extends AstNode {
    readonly $container: LocalEntity;
    readonly $type: 'EnumEntityAtribute';
    description?: string
    name: string
    type: Reference<EnumX>
}

export const EnumEntityAtribute = 'EnumEntityAtribute';

export function isEnumEntityAtribute(item: unknown): item is EnumEntityAtribute {
    return reflection.isInstance(item, EnumEntityAtribute);
}

export interface EnumX extends AstNode {
    readonly $container: Application | Module;
    readonly $type: 'EnumX';
    attributes: Array<AttributeEnum>
    description?: string
    name: string
}

export const EnumX = 'EnumX';

export function isEnumX(item: unknown): item is EnumX {
    return reflection.isInstance(item, EnumX);
}

export interface Equal extends AstNode {
    readonly $container: FunctionMapping;
    readonly $type: 'Equal';
    description?: string
    source: string
    target: Reference<Attribute>
}

export const Equal = 'Equal';

export function isEqual(item: unknown): item is Equal {
    return reflection.isInstance(item, Equal);
}

export interface EqualWhen extends AstNode {
    readonly $container: FunctionMapping;
    readonly $type: 'EqualWhen';
    source: string
    value: string
}

export const EqualWhen = 'EqualWhen';

export function isEqualWhen(item: unknown): item is EqualWhen {
    return reflection.isInstance(item, EqualWhen);
}

export interface FunctionMapping extends AstNode {
    readonly $container: LocalEntity;
    readonly $type: 'FunctionMapping';
    attributemappers: Array<AttributesMapper>
    description?: string
    name: QualifiedName
    source: string
    whenmappers: Array<WhenMapper>
}

export const FunctionMapping = 'FunctionMapping';

export function isFunctionMapping(item: unknown): item is FunctionMapping {
    return reflection.isInstance(item, FunctionMapping);
}

export interface LocalEntity extends AstNode {
    readonly $container: Module;
    readonly $type: 'LocalEntity';
    attributes: Array<Attribute>
    description?: string
    enumentityatributes: Array<EnumEntityAtribute>
    functions: Array<FunctionMapping>
    is_abstract: boolean
    name: string
    ontology?: Ontology
    relations: Array<Relation>
    superType?: Reference<Entity>
}

export const LocalEntity = 'LocalEntity';

export function isLocalEntity(item: unknown): item is LocalEntity {
    return reflection.isInstance(item, LocalEntity);
}

export interface ManyToMany extends AstNode {
    readonly $container: LocalEntity;
    readonly $type: 'ManyToMany';
    by?: Reference<LocalEntity>
    create: boolean
    description?: string
    fullName?: string
    name: string
    type: Reference<Entity>
}

export const ManyToMany = 'ManyToMany';

export function isManyToMany(item: unknown): item is ManyToMany {
    return reflection.isInstance(item, ManyToMany);
}

export interface ManyToOne extends AstNode {
    readonly $container: LocalEntity;
    readonly $type: 'ManyToOne';
    create: boolean
    description?: string
    fullName?: string
    name: string
    type: Reference<Entity>
}

export const ManyToOne = 'ManyToOne';

export function isManyToOne(item: unknown): item is ManyToOne {
    return reflection.isInstance(item, ManyToOne);
}

export interface Module extends AstNode {
    readonly $container: Application | Module;
    readonly $type: 'Module';
    description?: string
    elements: Array<AbstractElement | LocalEntity>
    name: QualifiedName
}

export const Module = 'Module';

export function isModule(item: unknown): item is Module {
    return reflection.isInstance(item, Module);
}

export interface OneToMany extends AstNode {
    readonly $container: LocalEntity;
    readonly $type: 'OneToMany';
    create: boolean
    description?: string
    fullName?: string
    name: string
    type: Reference<Entity>
}

export const OneToMany = 'OneToMany';

export function isOneToMany(item: unknown): item is OneToMany {
    return reflection.isInstance(item, OneToMany);
}

export interface OneToOne extends AstNode {
    readonly $container: LocalEntity;
    readonly $type: 'OneToOne';
    create: boolean
    description?: string
    fullName?: string
    name: string
    type: Reference<Entity>
}

export const OneToOne = 'OneToOne';

export function isOneToOne(item: unknown): item is OneToOne {
    return reflection.isInstance(item, OneToOne);
}

export interface Ontology extends AstNode {
    readonly $container: LocalEntity;
    readonly $type: 'Ontology';
    module: string
    ontology: string
}

export const Ontology = 'Ontology';

export function isOntology(item: unknown): item is Ontology {
    return reflection.isInstance(item, Ontology);
}

export interface StairwayAstType {
    AbstractElement: AbstractElement
    Application: Application
    Attribute: Attribute
    AttributeEnum: AttributeEnum
    AttributesMapper: AttributesMapper
    Configuration: Configuration
    Entity: Entity
    EnumEntityAtribute: EnumEntityAtribute
    EnumX: EnumX
    Equal: Equal
    EqualWhen: EqualWhen
    FunctionMapping: FunctionMapping
    LocalEntity: LocalEntity
    ManyToMany: ManyToMany
    ManyToOne: ManyToOne
    Module: Module
    OneToMany: OneToMany
    OneToOne: OneToOne
    Ontology: Ontology
    Relation: Relation
    WhenMapper: WhenMapper
}

export class StairwayAstReflection extends AbstractAstReflection {

    getAllTypes(): string[] {
        return ['AbstractElement', 'Application', 'Attribute', 'AttributeEnum', 'AttributesMapper', 'Configuration', 'Entity', 'EnumEntityAtribute', 'EnumX', 'Equal', 'EqualWhen', 'FunctionMapping', 'LocalEntity', 'ManyToMany', 'ManyToOne', 'Module', 'OneToMany', 'OneToOne', 'Ontology', 'Relation', 'WhenMapper'];
    }

    protected override computeIsSubtype(subtype: string, supertype: string): boolean {
        switch (subtype) {
            case EnumX:
            case Module: {
                return this.isSubtype(AbstractElement, supertype);
            }
            case Equal: {
                return this.isSubtype(AttributesMapper, supertype);
            }
            case EqualWhen: {
                return this.isSubtype(WhenMapper, supertype);
            }
            case LocalEntity: {
                return this.isSubtype(Entity, supertype);
            }
            case ManyToMany:
            case ManyToOne:
            case OneToMany:
            case OneToOne: {
                return this.isSubtype(Relation, supertype);
            }
            default: {
                return false;
            }
        }
    }

    getReferenceType(refInfo: ReferenceInfo): string {
        const referenceId = `${refInfo.container.$type}:${refInfo.property}`;
        switch (referenceId) {
            case 'EnumEntityAtribute:type': {
                return EnumX;
            }
            case 'Equal:target': {
                return Attribute;
            }
            case 'LocalEntity:superType':
            case 'ManyToMany:type':
            case 'ManyToOne:type':
            case 'OneToMany:type':
            case 'OneToOne:type': {
                return Entity;
            }
            case 'ManyToMany:by': {
                return LocalEntity;
            }
            default: {
                throw new Error(`${referenceId} is not a valid reference id.`);
            }
        }
    }

    getTypeMetaData(type: string): TypeMetaData {
        switch (type) {
            case 'Application': {
                return {
                    name: 'Application',
                    mandatory: [
                        { name: 'abstractElements', type: 'array' }
                    ]
                };
            }
            case 'Attribute': {
                return {
                    name: 'Attribute',
                    mandatory: [
                        { name: 'unique', type: 'boolean' }
                    ]
                };
            }
            case 'EnumX': {
                return {
                    name: 'EnumX',
                    mandatory: [
                        { name: 'attributes', type: 'array' }
                    ]
                };
            }
            case 'FunctionMapping': {
                return {
                    name: 'FunctionMapping',
                    mandatory: [
                        { name: 'attributemappers', type: 'array' },
                        { name: 'whenmappers', type: 'array' }
                    ]
                };
            }
            case 'LocalEntity': {
                return {
                    name: 'LocalEntity',
                    mandatory: [
                        { name: 'attributes', type: 'array' },
                        { name: 'enumentityatributes', type: 'array' },
                        { name: 'functions', type: 'array' },
                        { name: 'is_abstract', type: 'boolean' },
                        { name: 'relations', type: 'array' }
                    ]
                };
            }
            case 'ManyToMany': {
                return {
                    name: 'ManyToMany',
                    mandatory: [
                        { name: 'create', type: 'boolean' }
                    ]
                };
            }
            case 'ManyToOne': {
                return {
                    name: 'ManyToOne',
                    mandatory: [
                        { name: 'create', type: 'boolean' }
                    ]
                };
            }
            case 'Module': {
                return {
                    name: 'Module',
                    mandatory: [
                        { name: 'elements', type: 'array' }
                    ]
                };
            }
            case 'OneToMany': {
                return {
                    name: 'OneToMany',
                    mandatory: [
                        { name: 'create', type: 'boolean' }
                    ]
                };
            }
            case 'OneToOne': {
                return {
                    name: 'OneToOne',
                    mandatory: [
                        { name: 'create', type: 'boolean' }
                    ]
                };
            }
            default: {
                return {
                    name: type,
                    mandatory: []
                };
            }
        }
    }
}

export const reflection = new StairwayAstReflection();
